.586p
.model flat, stdcall
locals
jumps

include              c:\tasm32\include\shitheap.inc
include              scm.inc

o       equ     offset

extrn   MessageBoxA:proc
extrn   GetModuleHandleA:proc
extrn   GetProcAddress:proc
extrn   DeviceIoControl:proc

dumper_struct           struct
                        dump_start              dd      ?
                        dump_range              dd      ?
                        dump_fname              db      512     dup(0)
dumper_struct           ends 

.data
hscm            dd     ?
hservice        dd     ?
driverpath      db     256    dup (0)
drivername      db     "dumper.sys", 0
driverdesc      db     "dumper ring0 code....", 0
symlink:        unis   <\\.\dumper>
hdevice         dd     ?
dummy           dd     ?
dump            dumper_struct     ?

                        
.code
start:
                push    SC_MANAGER_CREATE_SERVICE
                push    0
                push    0
                callW   OpenSCManagerA
                test    eax, eax
                jz      __exit
                
                mov     hscm, eax
                
                push    offset dummy
                push    offset driverpath
                push    256
                push    offset drivername
                callW   GetFullPathNameA
                
                push    0
                push    0
                push    0
                push    0
                push    0
                push    offset driverpath
                push    SERVICE_ERROR_IGNORE
                push    SERVICE_DEMAND_START
                push    SERVICE_KERNEL_DRIVER
                push    SERVICE_START or DELETE or SERVICE_STOP
                push    offset driverdesc
                push    offset drivername
                push    hscm
                callW   CreateServiceA                
                test    eax, eax
                jz      __try_to_openservice
                
                mov     hservice, eax
                
__try_to_start: 
                push    0
                push    0
                push    eax
                callW   StartServiceA

                push    0
                push    0
                push    OPEN_EXISTING
                push    0
                push    0
                push    GENERIC_READ + GENERIC_WRITE
                push    offset symlink
                callW   CreateFileW
                mov     hdevice, eax

                push    0
                call    GetModuleHandleA
                
                push    0
                push    offset dialogproc
                push    0
                push    999
                push    eax
                callW   DialogBoxParamW
                
               
__done:                
                push    hdevice
                callW   CloseHandle
                     
__closeservice:
                push    offset dummy
                push    SERVICE_CONTROL_STOP
                push    hservice
                callW   ControlService
                
                push    hservice
                callW   DeleteService
                
                push    hservice
                callW   CloseServiceHandle
                

                
__close_scm:    push    hscm
                callW   CloseServiceHandle
                
__exit:
                push    0
                callW   ExitProcess
                

   
                     
                    
__try_to_openservice:                    
                push    SC_MANAGER_ALL_ACCESS
                push    offset drivername
                push    hscm
                callW   OpenServiceA
                test    eax, eax
                jz      __close_scm
                mov     hservice, eax
                jmp     __try_to_start

dialogproc      proc    hdlg:dword, wmsg:dword, wparam:dword, lparam:dword
                pushad
                xor     eax, eax
                cmp     wmsg, WM_COMMAND
                je      __wmcommand
                cmp     wmsg, WM_INITDIALOG
                je      __wminit
                cmp     wmsg, WM_CLOSE
                jne     __exitdialog
                
                push    0
                push    hdlg
                callW   EndDialog
                mov     eax, 1
                jmp     __exitdialog

__wminit:       push    9999
                call    GetModuleHandleA, 0
                push    eax
                callW   LoadIconA
                
                push    eax
                push    ICON_SMALL
                push    WM_SETICON
                push    hdlg
                callW   SendMessageA
                
                pushs   <"dumper ready...">
                push    8
                push    hdlg
                callW   SetDlgItemTextA
                
                mov     eax, 1
                jmp     __exitdialog

                
__wmcommand:    cmp     wparam, 4
                jne     __wmcommand0

                push    40h
                pushs   <"ring0 dumper">
                push    offset mabout
                push    hdlg
                call    MessageBoxA
                mov     eax, 1
                jmp     __exitdialog

__wmcommand0:                
                cmp     wparam, 3
                jne     __exitdialog
                
                mov     edi, offset filename
                mov     ecx, buffersize
                xor     al, al
                cld
                rep     stosb
                 
                push    9
                push    offset address                
                push    0
                push    hdlg
                callW   GetDlgItemTextA
                test    eax, eax
                jz      __exitdialog
                call    htodw, offset address
                mov     dump.dump_start, eax
                
                push    9
                push    offset rangesize
                push    1
                push    hdlg
                callW   GetDlgItemTextA
                test    eax, eax
                jz      __exitdialog
                call    htodw, offset rangesize
                mov     dump.dump_range, eax
                
                push    256
                push    offset filename
                push    2
                push    hdlg
                callW   GetDlgItemTextW
                test    eax, eax
                jz      __exitdialog
                
                lea     edi, dump.dump_fname
                mov     esi, offset driveprefix
                mov     ecx, 500
                rep     movsb
                
                call   DeviceIoControl, hdevice, 20h, o dump, size dumper_struct, o dump, size dumper_struct, o dummy, 0
                
                push    offset dump
                push    8
                push    hdlg
                callW   SetDlgItemTextA
                mov     eax, 1
                                
__exitdialog:   mov     [esp.Pushad_eax], eax
                popad
                ret
                endp
driveprefix     dw      '\','?','?','\'
filename        db      512     dup(0)
address         db      10h       dup(0)
rangesize       db      10h       dup(0)
buffersize      =       $-filename

mabout          db      "ring0 dumper", 13, 10
                db      "dump ring0 memory to file", 13, 10
                db      "Use DebugView to see driver output", 13, 10
                db      13, 10
                db      "               S verom u Boga, deroko/ARTeam", 0
include         htodw.inc
                     
                end     start     
